import numpy as np
import matplotlib.pyplot as plt

def parse_file(f):
    return np.loadtxt(f,dtype=int,delimiter=",").transpose()

def add_x(a,x):
    y,n=a.shape
    ar=np.zeros((2*y,n))
    for i in range(y):
        ar[2*i,:]=x
        ar[2*i+1,:]=a[i,:]
    return ar

def add_time(a):
    n=a.shape[1]
    time=np.linspace(0,n/30,n) # parce qu'on est à 30Hz
    return add_x(a,time)

def moving_average(a, n=5) :
    ret = np.cumsum(a, dtype=float)
    ret[n:] = ret[n:] - ret[:-n]
    ret[n - 1:] /= n
    for i in range(n-1):
        ret[i]/=(i+1)
    return np.array((*ret[n//2:],*[ret[-1]for i in range(n//2)]))

def dilate(a,n=5):
    ret=np.zeros(len(a))
    for i in range(len(a)):
        ret[i]=max(a[max(0,i-n):i+n])
    return ret

def norm_acc(a):
    return np.sqrt(np.sum(a**2,axis=0))
