import serial
import serial.tools.list_ports
import datetime
import os

print("Liste des ports COM :")
l = list((serial.tools.list_ports.comports()))
print(*l)

def find_port():
    l = list((serial.tools.list_ports.comports()))    
    for p in l:
        if "USB-SERIAL CH340" in p[1]:
            return p[0]
def dcode(s):
    return s.decode("utf-8").replace("\r\n","")
def gall(ser):
    return (dcode(a) for a in ser.readlines())
def pall(ser):
    l=dcode(ser.readline())
    while l:
        print(l)
        l=dcode(ser.readline())
def send(ser,s):
    ser.write(bytes(s+"\n",'utf-8'));

port=find_port()

with serial.Serial(port,115200,timeout=2) as ser:
    print("Accéléromètre détecté sur le port",port)
    pall(ser)
    send(ser,"end")
    ser.readline()
    ser.readline()
    ser.timeout=0.1 # pour ne pas attendre trop lorsqu'on lit plusieurs lignes
    send(ser,"dir")
    files = gall(ser)
    date = datetime.datetime.now()
    dname = "csv/"+"-".join(map(str,(date.year,date.month,date.day,date.hour,date.minute,date.second)))
    print("Téléchargement des fichiers dans le dossier",dname+".")
    os.mkdir(dname)
    for f in files:
        print("Téléchargement de",f)
        send(ser,"size "+f)
        s=int(ser.readline())
        print("Taille :",s)
        send(ser,"open "+f)
        data=ser.read(s)
        with open(dname+"/"+f,"wb") as rf:
            rf.write(data)
        print("Téléchargement terminé, suppression du fichier.")
        send(ser,"rm "+f)
        print(dcode(ser.readline()))
        
    pall(ser)
